
################################################################################
# stages for flight core px4 projects in px4 docker build environment
################################################################################



################################################################################
# dev builds for fcv1 and 2 on every commit to dev branch
################################################################################

build_fcv1_px4_dev:
  image: px4io/px4-dev-nuttx-focal:2022-08-12
  stage: build
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - cd px4-firmware
    - make modalai_fc-v1
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    GIT_STRATEGY: clone
  artifacts:
    expire_in: 20 min
    paths:
      - "px4-firmware/build/modalai_fc-v1_default/modalai_fc-v1_*.px4"
      - "px4-firmware/build/modalai_fc-v1_default/modalai_fc-v1_*.bin"
      - "pkg/control/control"



build_fcv2_px4_dev:
  image: px4io/px4-dev-nuttx-focal:2022-08-12
  stage: build
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - cd px4-firmware
    - make modalai_fc-v2_bootloader
    - make modalai_fc-v2
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    GIT_STRATEGY: clone
  artifacts:
    expire_in: 20 min
    paths:
      - "px4-firmware/build/modalai_fc-v2_default/modalai_fc-v2_*.px4"
      - "px4-firmware/build/modalai_fc-v2_default/modalai_fc-v2_*.bin"
      - "pkg/control/control"



################################################################################
# deploy dev builds for fcv1 and 2 on every commit to dev branch
################################################################################

deploy_fcv1_px4_dev:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_fcv1_px4_dev
  dependencies:
    - build_fcv1_px4_dev
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    GIT_STRATEGY: none
    PLATFORM: fc-v1
  script:
    - /bin/bash ci-tools/scripts/deploy-fc-repo.sh
    - date


deploy_fcv2_px4_dev:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_fcv2_px4_dev
  dependencies:
    - build_fcv2_px4_dev
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    GIT_STRATEGY: none
    PLATFORM: fc-v2
  script:
    - /bin/bash ci-tools/scripts/deploy-fc-repo.sh
    - date


################################################################################
# staging builds for fcv1 and 2 on every tag to master branch
################################################################################

build_fcv1_px4_tag:
  image: px4io/px4-dev-nuttx-focal:2022-08-12
  stage: build
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_COMMIT_BRANCH != "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - cd px4-firmware
    - make modalai_fc-v1
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    GIT_STRATEGY: clone
  artifacts:
    expire_in: 20 min
    paths:
      - "px4-firmware/build/modalai_fc-v1_default/modalai_fc-v1_*.px4"
      - "px4-firmware/build/modalai_fc-v1_default/modalai_fc-v1_*.bin"
      - "pkg/control/control"



build_fcv2_px4_tag:
  image: px4io/px4-dev-nuttx-focal:2022-08-12
  stage: build
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_COMMIT_BRANCH != "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - cd px4-firmware
    - make modalai_fc-v2_bootloader
    - make modalai_fc-v2
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    GIT_STRATEGY: clone
  artifacts:
    expire_in: 20 min
    paths:
      - "px4-firmware/build/modalai_fc-v2_default/modalai_fc-v2_*.px4"
      - "px4-firmware/build/modalai_fc-v2_default/modalai_fc-v2_*.bin"
      - "pkg/control/control"


################################################################################
# deploy staging builds for fcv1 and 2 on every tag to master
################################################################################

deploy_fcv1_px4_tag:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_fcv1_px4_tag
  dependencies:
    - build_fcv1_px4_tag
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    GIT_STRATEGY: none
    PLATFORM: fc-v1
  script:
    - /bin/bash ci-tools/scripts/deploy-fc-repo.sh
    - date


deploy_fcv2_px4_tag:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_fcv2_px4_tag
  dependencies:
    - build_fcv2_px4_tag
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    GIT_STRATEGY: none
    PLATFORM: fc-v2
  script:
    - /bin/bash ci-tools/scripts/deploy-fc-repo.sh
    - date
